
// Matrices

shared float4x4 ViewProj : ViewProjection < string UIWidget = "None"; >;
float4x4 World : World < string UIWidget = "None"; >;

shared float3 SunDir = { 0.3725, 0.85, 0.3725 };
shared float3 AmbientColor = { 0.4, 0.4, 0.4 };
float3 Color;

// Connector data structures

struct appData {
	float2 Position	: POSITION;
	float4 Normal	: NORMAL;
};

struct vertexOutput {
	float4 HPosition	: POSITION;
	float3 Color		: COLOR;
};

vertexOutput mainVS(appData IN){
	vertexOutput OUT;
	
	float4 Po = float4(IN.Position.x, IN.Normal.w, IN.Position.y, 1.0);
	float4x4 WorldViewProj = mul(World, ViewProj);
	
	OUT.HPosition = mul(Po, WorldViewProj);
	OUT.Color = (AmbientColor + (1.0 - AmbientColor) * saturate(dot(IN.Normal.xyz, SunDir))) * Color;
	
	return OUT;
}

float4 mainPS(vertexOutput IN) : COLOR {
	return float4(IN.Color, 1.0);
}

technique Main {
	pass p0 {
		VertexShader = compile vs_2_0 mainVS();
		ZEnable = true;
		ZWriteEnable = true;
		ZFunc = LessEqual;
		AlphaBlendEnable = false;
		CullMode = CCw;
		FillMode = Solid;
		PixelShader = compile ps_2_0 mainPS();
	}
}
