
// Matrices

shared float4x4 ViewProj : ViewProjection < string UIWidget = "None"; >;
shared float Width;
shared float Height;

float Scale = 10.0f;

// Textures

texture ColorTexture : DIFFUSE;

sampler2D ColorSampler = sampler_state {
    Texture = <ColorTexture>;
    FILTER = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

// Connector data structures

struct appData {
	float3 Position	: POSITION;
	float2 UV		: TEXCOORD0;
};

struct vertexOutput {
	float4 HPosition	: POSITION;
	//float4 Color		: COLOR;
	float2 UV			: TEXCOORD0;
};

vertexOutput mainVS(appData IN){
	vertexOutput OUT;
	
	float4 pos = mul(float4(IN.Position, 1.0), ViewProj);
	float2 scale = (IN.UV.xy - 0.5) * Scale;
	scale.y *= Width / Height;
	OUT.HPosition = pos + float4(scale, 0.0, 0.0);
	//OUT.Color = IN.Color * float4(Color, 1.0);
	OUT.UV = IN.UV.xy;	
	
	return OUT;
}

float4 mainPS(vertexOutput IN) : COLOR {
	return float4(0.1, 0.1, 0.1, tex2D(ColorSampler, IN.UV).x);
}

technique Main {
	pass p0 {
		VertexShader = compile vs_2_0 mainVS();
		ZEnable = false;
		ZWriteEnable = false;
		ZFunc = LessEqual;
		AlphaBlendEnable = true;
		SrcBlend = SrcAlpha;
		DestBlend = One;
		CullMode = None;
		PixelShader = compile ps_2_0 mainPS();
	}
}
