
// Matrices

shared float4x4 ViewProj : ViewProjection < string UIWidget = "None"; >;
float4x4 World : World < string UIWidget = "None"; >;

// Connector data structures

struct appData {
	float3 Position	: POSITION;
	float3 Color	: COLOR;
};

struct vertexOutput {
	float4 HPosition	: POSITION;
	float3 Color		: COLOR;
};

vertexOutput mainVS(appData IN){
	vertexOutput OUT;
	float4x4 WorldViewProj = mul(World, ViewProj);
	
	OUT.HPosition = mul(float4(IN.Position, 1.0), WorldViewProj);
	OUT.Color = IN.Color;
	
	return OUT;
}

float4 mainPS(vertexOutput IN) : COLOR {
	return float4(IN.Color, 1.0);
}

technique Main {
	pass p0 {
		VertexShader = compile vs_2_0 mainVS();
		ZEnable = true;
		ZWriteEnable = true;
		ZFunc = LessEqual;
		AlphaBlendEnable = false;
		CullMode = None;
		PixelShader = compile ps_2_0 mainPS();
	}
}
