
// Matrices

shared float4x4 ViewProj : ViewProjection < string UIWidget = "None"; >;
float4x4 World : World < string UIWidget = "None"; >;

float Size;
float3 Color;

// Textures

texture density;

sampler2D DensitySampler = sampler_state {
    Texture = <density>;
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = CLAMP;
    AddressV = CLAMP;
};

// Connector data structures

struct appData {
	float2 Position	: POSITION;
	float4 Normal	: NORMAL;
};

struct vertexOutput {
	float4 HPosition	: POSITION;
	float2 UV			: TEXCOORD0;
};

vertexOutput mainVS(appData IN){
	vertexOutput OUT;
	float4 Po = float4(IN.Position.x, IN.Normal.w, IN.Position.y, 1.0);
	float4x4 WorldViewProj = mul(World, ViewProj);
	
	OUT.HPosition = mul(Po, WorldViewProj);
	OUT.UV = IN.Position.xy / Size;
	
	return OUT;
}

float4 mainPS(vertexOutput IN) : COLOR {
	return float4(tex2D(DensitySampler, IN.UV).x * Color, 1.0);
}

technique Main {
	pass p0 {
		VertexShader = compile vs_2_0 mainVS();
		ZEnable = true;
		ZWriteEnable = true;
		ZFunc = LessEqual;
		AlphaBlendEnable = false;
		CullMode = CCw;
		FillMode = Solid;
		PixelShader = compile ps_2_0 mainPS();
	}
}
