
shared float2 OneOverScreenSize;
float Alpha;

// Textures

texture ColorMap;

sampler2D ColorSampler = sampler_state {
    Texture = <ColorMap>;
    FILTER = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

// Connector data structures

struct appData {
	float2 Position	: POSITION;
	float2 UV	: TEXCOORD0;
};

struct vertexOutput {
	float4 HPosition	: POSITION;
	float2 UV			: TEXCOORD0;
};

vertexOutput mainVS(appData IN){
	vertexOutput OUT;
	
	OUT.HPosition = float4(2.0f * IN.Position * OneOverScreenSize - 1.0f, 0.0f, 1.0f);
	OUT.HPosition.y = -OUT.HPosition.y;
	OUT.UV = IN.UV;
	
	return OUT;
}

float4 mainPS(vertexOutput IN) : COLOR {
	float4 color = tex2D(ColorSampler, IN.UV);
	return float4(color.xyz, color.w * Alpha);
}

technique Main {
	pass p0 {
		VertexShader = compile vs_2_0 mainVS();
		ZEnable = false;
		ZWriteEnable = false;
		AlphaBlendEnable = true;
		SrcBlend = SrcAlpha;
		DestBlend = InvSrcAlpha;
		CullMode = None;
		FillMode = Solid;
		PixelShader = compile ps_2_0 mainPS();
	}
}
