
// Matrices

shared float4x4 ViewProj : ViewProjection < string UIWidget = "None"; >;
float4x4 World : World < string UIWidget = "None"; >;

float Height;

// Connector data structures

struct appData {
	float2 Position	: POSITION;
};

struct vertexOutput {
	float4 HPosition	: POSITION;
};

vertexOutput mainVS(appData IN){
	vertexOutput OUT;
	float4 Po = float4(IN.Position.x, Height, IN.Position.y, 1.0);
	float4x4 WorldViewProj = mul(World, ViewProj);
	
	OUT.HPosition = mul(Po, WorldViewProj);
	
	return OUT;
}

float4 mainPS(vertexOutput IN) : COLOR {
	return float4(0.0, 0.0, 1.0, 1.0);
}

technique Main {
	pass p0 {
		VertexShader = compile vs_2_0 mainVS();
		ZEnable = true;
		ZWriteEnable = true;
		ZFunc = LessEqual;
		AlphaBlendEnable = false;
		CullMode = CCw;
		FillMode = Solid;
		PixelShader = compile ps_2_0 mainPS();
	}
}
