#ifndef APOLOC
#define APOLOC

#include <XAPOBase.h>

struct APOLocParams
{
	float elev;
	float azim;
};

class APOLoc: public CXAPOParametersBase
{
public:
	APOLoc();
	virtual ~APOLoc();

	STDMETHOD(LockForProcess)(
		UINT32 InputLockedParameterCount, const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS* pInputLockedParameters,
		UINT32 OutputLockedParameterCount, const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS* pOutputLockedParameters);
	STDMETHOD_(void, Process)(
		UINT32 InputProcessParameterCount, const XAPO_PROCESS_BUFFER_PARAMETERS* pInputProcessParameters,
		UINT32 OutputProcessParameterCount, XAPO_PROCESS_BUFFER_PARAMETERS* pOutputProcessParameters, BOOL IsEnabled);

private:
	float			*m_workBuffer;
	APOLocParams	 m_parameters[3];

	static XAPO_REGISTRATION_PROPERTIES m_regProperties;
};

#endif