#ifndef H_ALLOTMENT
#define H_ALLOTMENT

#include <d3dx9.h>
#include "Buffer.h"
#include <vector>

typedef struct {
	int index;
	D3DXVECTOR3 n, v1, v2, vector;
	float length;
	bool marker;
} Edge;
enum ZoneType;

class Allotment
{
public:
	Allotment(ZoneType type, const std::vector<D3DXVECTOR3> &vertices);
	Allotment(ZoneType type, const std::vector<D3DXVECTOR3> &vertices, const std::vector<bool> &markers);
	~Allotment(void);
	D3DXVECTOR2 gravityCenter();
	std::vector<Edge> & getEdges(void);
	std::vector<D3DXVECTOR3> & getVertices(void);
	D3DXVECTOR2 getPosition();
	void addVertex(const D3DXVECTOR3 &v);
	void addEdge(const Edge &e);
	bool isIn();

	ZoneType getZoneType() const;
	void setZoneType(ZoneType type);

private:
	D3DXVECTOR2 m_position;
	std::vector<D3DXVECTOR3> m_vertices;
	std::vector<Edge> m_edges;
	ZoneType	m_type;
};
#endif