#ifndef H_BLOCK
#define H_BLOCK

#include <vector>
#include <d3dx9.h>

class Building;
enum ZoneType;

class Block
{
public:
	Block(std::vector<D3DXVECTOR3>& vertices, ZoneType type);
	~Block(void);
	/* Getters et Setters */
	const std::vector<D3DXVECTOR3>& getVertices() const;
	std::vector<D3DXVECTOR3>& getVertices();
	ZoneType getZoneType() const;
	const std::vector<Building*>& getBuildings() const;
	void setType(const ZoneType type);
	void addVertex(const D3DXVECTOR3 &vertex);
	void addBuilding(Building& building);
	bool pointInside(const D3DXVECTOR2 &point) const;

private:
	std::vector<D3DXVECTOR3> m_vertices;
	ZoneType m_type;
	std::vector<Building*> m_buildings;
};

#endif