#ifndef H_BUFFER
#define H_BUFFER

#include <d3d9.h>

template <class T, class Type>
class Buffer
{
public:
	Buffer(unsigned size, Type buffer);
	~Buffer();

	T * lock();
	T * lock(unsigned offset);
	T * lock(unsigned offset, unsigned size);
	void unlock();
	void fill(const T *data, unsigned size);

	unsigned getSize() const;
	Type getBuffer() const;

private:
	Type		 m_buffer;
	unsigned	 m_size;
	void		*m_saveData;
};

#include "Buffer.inl"

template <class T>
struct VertexBuffer
{
	typedef Buffer<T, LPDIRECT3DVERTEXBUFFER9> Type;
};

template <class T>
struct IndexBuffer
{
	typedef Buffer<T, LPDIRECT3DINDEXBUFFER9> Type;
};

#endif