#include "Building.h"
#include "MemoryLog.h"

Building::Building(Allotment *allotment, float height /*, Mesh */):
m_allotment(allotment),
m_height(height)
{
}

Building::~Building(void)
{
}

void Building::addIndex(unsigned index)
{
	m_indices.push_back(index);
}

void Building::addVertex(const D3DXVECTOR3 &vertex)
{
	m_vertices.push_back(vertex);
}

void Building::computeNormals()
{
	m_normals.resize(m_vertices.size(), D3DXVECTOR3(0.0f, 0.0f, 0.0f));

	for(unsigned i = 0; i < m_indices.size(); i += 3)
	{
		D3DXVECTOR3 u = m_vertices[m_indices[i + 1]] - m_vertices[m_indices[i]];
		D3DXVECTOR3 v = m_vertices[m_indices[i + 2]] - m_vertices[m_indices[i]];
		D3DXVECTOR3 w;
		D3DXVec3Cross(&w, &u, &v);

		if(D3DXVec3LengthSq(&w) > 0.00000001f)
		{
			D3DXVec3Normalize(&w, &w);

			for(unsigned j = 0; j < 3; ++j)
			{
				m_normals[m_indices[i + j]] += w;
			}
		}
	}

	for(unsigned i = 0; i < m_normals.size(); ++i)
	{
		D3DXVec3Normalize(&m_normals[i], &m_normals[i]);
	}
}


/**************************************************************************************************
					Getters et Setters
**************************************************************************************************/
Allotment& Building::getAllotment() const
{
	return *m_allotment;
}

const std::vector<D3DXVECTOR3> & Building::getVertices()const
{
	return m_vertices;
}

const std::vector<D3DXVECTOR3> & Building::getNormals()const
{
	return m_normals;
}

const std::vector<unsigned> & Building::getIndices() const
{
	return m_indices;
}