#ifndef H_BUILDING
#define H_BUILDING

#include <d3dx9.h>
#include <list>
#include <vector>
#include "Allotment.h"

typedef struct {std::vector<D3DXVECTOR3> vertices; std::vector<Edge> edges;} Face;

class Building
{
public:
	Building(Allotment *allotment, float height /*, Mesh */); 
	~Building(void);
	/* Getters et Setters */
	Allotment& getAllotment()const;
	const std::vector<D3DXVECTOR3> & getVertices()const;
	const std::vector<D3DXVECTOR3> & getNormals() const;
	const std::vector<unsigned> & getIndices() const;
	void addIndex(unsigned index);
	void addVertex(const D3DXVECTOR3 &vertex);
	void computeNormals();

private:
	Allotment *m_allotment;
	std::vector<D3DXVECTOR3> m_vertices;
	std::vector<D3DXVECTOR3> m_normals;
	std::vector<unsigned> m_indices;
	float m_height;
	// Mesh
};

#endif