#ifndef H_CAMERA
#define H_CAMERA

#include "Listener.h"
#include <windows.h>
#include <windowsx.h>
#include <d3dx9.h>

class Camera
{
private:
	D3DXVECTOR3 m_position;
	float m_rotations[2];
	D3DXMATRIX m_viewMatrix;

public:
	Camera( void ); 
	~Camera( void );

	void setPosition( const D3DXVECTOR3& p );

	void rotateX(float var);
	void rotateY(float var);

	void translateX(float var);
	void translateY(float var);
	void translateZ(float var);

	const D3DXVECTOR3& getPosition( void ) const;
	const D3DXMATRIX& getViewMatrix( void ) const;
    
	void update();
};
#endif
