#ifndef H_COMMANDFRAME
#define H_COMMANDFRAME

#include "GUIFrame.h"
#include "GUIEvent.h"

class GUIListBox;
class GUILabel;
class Control;

enum ECommandFrameMode
{
	CFM_GENERATION,
	CFM_SIMULATION,

	CFM_NB_MODES
};

class CommandFrame: public GUIFrame
{
public:
	CommandFrame(GUI *gui);

	void setCurrentStage(int index);
	void setMode(ECommandFrameMode mode);

	void addControl(Control *control);
	Control * getControl(unsigned index) const;
	Control * getSimulationControl() const;

	void setAverageSpeed(float averageSpeed);

	GUIEvent<void> onClear;
	GUIEvent<void> onStep;
	GUIEvent<void> onRun;
	GUIEvent<void> onRunAll;

	GUIEvent<void> onStartSimulation;
	GUIEvent<void> onStopSimulation;
	GUIEvent<void> onSetupAgents;
	GUIEvent<bool> onShowBottlenecks;

protected:
	void refreshControlsPosition();
	void selectControl(int index);
	void saveParameters();
	void loadParameters();

private:
	GUIListBox				*m_list;
	GUIWindow				*m_buttons;
	std::vector<Control *>	 m_controls;
	Control					*m_simulationControl;
	GUILabel				*m_averageSpeedLabel;

	GUIWindow				*m_panels[CFM_NB_MODES];
};

#endif