#ifndef H_CROSSING
#define H_CROSSING

#include <vector>
#include <d3dx9.h>

class Road;

class Crossing
{
public:
	Crossing(const D3DXVECTOR3 &pos);
	~Crossing(void);
	/* getters et setters */
	const D3DXVECTOR3& getPosition() const;
	D3DXVECTOR3 & getPosition();
	D3DXVECTOR2 get2DPosition() const;
	const std::vector<const Road*>& getRoads() const;
	void addRoad (const Road& r);
	void removeRoad(const Road &r);
	void setPosition(const D3DXVECTOR3& position);

	bool isNeighbor(const Crossing *c) const;
	bool isNeighbor(const Road *r) const;
	bool hasColinearRoad(const Road *r, float cosTreshold) const;
	unsigned getNbStreet() const;

	void sortRoad();
	int getRoadIndex(const Road *r) const;

	void setJunctionPositions(std::vector<D3DXVECTOR3> &positions);
	D3DXVECTOR3 getJunctionPosition(unsigned index) const;

private:
	D3DXVECTOR3							m_position;
	std::vector<const Road*>			m_roads;
	std::vector<D3DXVECTOR3>			m_junctionPositions;
};

#endif