#ifndef H_DEBUG
#define H_DEBUG

#include <exception>
#include <cassert>

class AssertException: public std::exception
{
public:
	AssertException(const char *expression): std::exception(expression)
	{
	}
};

#ifdef _DEBUG
#define _TOSTR(exp) #exp
#define TOSTR(exp) _TOSTR(exp)
#define Assert(exp) (!!(exp) || (__debugbreak(), throw AssertException("Assert Failed in " __FILE__ " (" TOSTR(__LINE__) ") : " #exp), true))
#else
#define Assert(exp)
#endif

#endif