#include "Declaration.h"
#include "MemoryLog.h"

static const WORD d3dTypeSize[] =
{ 4, 8, 12, 16, 4, 4, 4, 8, 4, 4, 8, 4, 8, 12, 12, 4, 8, 0 };

#define MAX_STREAM 16

Declaration::Declaration(LPDIRECT3DDEVICE9 device, DeclarationElement elems[], unsigned nb)
{
	D3DVERTEXELEMENT9 *dxElems = new D3DVERTEXELEMENT9[nb + 1];
	WORD offset[MAX_STREAM] = { 0 };

	for(unsigned i = 0; i < nb; ++i)
	{
		dxElems[i].Stream = elems[i].stream;
		dxElems[i].Offset = offset[elems[i].stream];
		dxElems[i].Type = elems[i].type;
		dxElems[i].Method = D3DDECLMETHOD_DEFAULT;
		dxElems[i].Usage = elems[i].usage;
		dxElems[i].UsageIndex = 0;
		offset[elems[i].stream] += d3dTypeSize[elems[i].type];
	}

	dxElems[nb].Stream = 0xFF;
	dxElems[nb].Offset = 0;
	dxElems[nb].Type = D3DDECLTYPE_UNUSED;
	dxElems[nb].Method = 0;
	dxElems[nb].Usage = 0;
	dxElems[nb].UsageIndex = 0;

	device->CreateVertexDeclaration(dxElems, &m_decl);
	delete[] dxElems;
}

Declaration::~Declaration()
{
	m_decl->Release();
}

LPDIRECT3DVERTEXDECLARATION9 Declaration::getDeclaration() const
{
	return m_decl;
}