#include "MemoryLog.h"

template <class Param>
IDelegate<Param>::~IDelegate()
{
}


template <class T, class Param>
Delegate<T, Param>::Delegate(T *classPtr, PtrFuncType ptrFunc):
m_classPtr(classPtr),
m_ptrFunc(ptrFunc)
{
}

template <class T, class Param>
Delegate<T, Param>::~Delegate()
{
}

template <class T, class Param>
void Delegate<T, Param>::operator ()(GUIWindow *sender, Param p) const
{
	((*m_classPtr).*m_ptrFunc)(sender, p);
}


template <class T>
Delegate<T, void>::Delegate(T *classPtr, PtrFuncType ptrFunc):
m_classPtr(classPtr),
m_ptrFunc(ptrFunc)
{
}

template <class T>
Delegate<T, void>::~Delegate()
{
}

template <class T>
void Delegate<T, void>::operator ()(GUIWindow *sender) const
{
	((*m_classPtr).*m_ptrFunc)(sender);
}


template <class T, class Param>
BlindDelegate<T, Param>::BlindDelegate(T *classPtr, PtrFuncType ptrFunc):
m_classPtr(classPtr),
m_ptrFunc(ptrFunc)
{
}

template <class T, class Param>
BlindDelegate<T, Param>::~BlindDelegate()
{
}

template <class T, class Param>
void BlindDelegate<T, Param>::operator ()(GUIWindow *, Param p) const
{
	((*m_classPtr).*m_ptrFunc)(p);
}


template <class T>
BlindDelegate<T, void>::BlindDelegate(T *classPtr, PtrFuncType ptrFunc):
m_classPtr(classPtr),
m_ptrFunc(ptrFunc)
{
}

template <class T>
BlindDelegate<T, void>::~BlindDelegate()
{
}

template <class T>
void BlindDelegate<T, void>::operator ()(GUIWindow *) const
{
	((*m_classPtr).*m_ptrFunc)();
}

#undef new