#ifndef H_FFT
#define H_FFT

#include "utils.h"
#include <complex>

#define FFT_NB_POINTS 256
#define FFT_LOG_POINTS (StaticLog<FFT_NB_POINTS>::Value)

class FFT
{
public:
	FFT();

	void operator()(const float *data, std::complex<float> *outBuffer);
	void operator()(std::complex<float> *data, float *outBuffer);

protected:
	void convertData(const float *data, std::complex<float> *buffer);
	void convertData(std::complex<float> *buffer);
	void outputData(const std::complex<float> *data, float *outBuffer);

private:
	unsigned			m_reverseOrder[FFT_NB_POINTS];
	std::complex<float>	m_exponentials[FFT_NB_POINTS * FFT_LOG_POINTS];
};

extern FFT fastFourierTransform;

#endif