#include "Font.h"
#include "MemoryLog.h"

Font::Font(LPD3DXFONT font):
m_font(font)
{
}

Font::~Font()
{
	m_font->Release();
}

void Font::onLostDevice()
{
	m_font->OnLostDevice();
}

void Font::onResetDevice()
{
	m_font->OnResetDevice();
}

LPD3DXFONT Font::getD3DPtr() const
{
	return m_font;
}

void Font::getTextSize(const std::string &text, D3DXVECTOR2 &size) const
{
	RECT rc = { 0, 0, 0, 0 };

	m_font->DrawText(NULL, text.c_str(), -1, &rc, DT_SINGLELINE | DT_NOCLIP | DT_CALCRECT, 0xFFFFFFFF);

	size.x = static_cast<float>(rc.right);
	size.y = static_cast<float>(rc.bottom);
}