#include "FontLoader.h"
#include <sstream>
#include "MediaManager.h"
#include "Renderer.h"
#include "MemoryLog.h"

FontLoader::~FontLoader()
{
}

Font * FontLoader::load(const std::string &fileName, MediaManager &media) const
{
	const std::string &file = fileName.substr(0, fileName.find_last_of('.'));
	size_t pos = file.find_last_of('.');
	const std::string &fontName = file.substr(0, pos);
	const std::string &sizeStr = file.substr(pos + 1);
	std::istringstream buf(sizeStr);
	unsigned size;
	
	buf >> size;

	return media.getRenderer().createFont(fontName, size);
}