#ifndef H_GUIBUTTON
#define H_GUIBUTTON

#include "GUIWindow.h"
#include "GUIEvent.h"

class GUITexture;

class GUIButton: public GUIWindow
{
public:
	GUIButton(GUI *gui, const std::string &name, GUIWindow *parent, const std::string &caption);
	virtual ~GUIButton();

	void setTogglable(bool togglable);
	bool isPressed() const;

	GUIEvent<void> onClick;
	GUIEvent<bool> onPress;
	GUIEvent<void> onRelease;

protected:
	virtual void renderSelf(Renderer &renderer) const;
	virtual void onMouseEnter(const D3DXVECTOR2 &lastPos, const D3DXVECTOR2 &pos);
	virtual void onMouseLeave(const D3DXVECTOR2 &lastPos, const D3DXVECTOR2 &pos);
	virtual bool onMouseClick(const D3DXVECTOR2 &pos, unsigned button);
	virtual bool onMouseRelease(const D3DXVECTOR2 &pos, unsigned button);

private:
	unsigned	 m_actTexture;
	GUITexture	*m_textures[4];
	bool		 m_togglable;
	bool		 m_pressed;
};

#endif