#include "GUIEvent.h"
#include "MemoryLog.h"

GUIEvent<void>::GUIEvent()
{
}

GUIEvent<void>::~GUIEvent()
{
	for(std::vector<IDelegate<void> *>::iterator it = m_delegates.begin(); it != m_delegates.end(); ++it)
	{
		delete (*it);
	}
}

void GUIEvent<void>::operator +=(IDelegate<void> *delegate)
{
	m_delegates.push_back(delegate);
}

void GUIEvent<void>::operator ()(GUIWindow *sender)
{
	for(std::vector<IDelegate<void> *>::iterator it = m_delegates.begin(); it != m_delegates.end(); ++it)
	{
		(**it)(sender);
	}
}

bool GUIEvent<void>::hasDelegate() const
{
	return !m_delegates.empty();
}