#ifndef H_GUIEVENT
#define H_GUIEVENT

#include <vector>
#include "Delegate.h"

template <class Param>
class GUIEvent
{
public:
	GUIEvent();
	~GUIEvent();

	void operator +=(IDelegate<Param> *delegate);
	void operator ()(GUIWindow *sender, Param p);

	bool hasDelegate() const;

private:
	GUIEvent(const GUIEvent &event);
	GUIEvent & operator =(const GUIEvent &);

	std::vector<IDelegate<Param> *>	m_delegates;
};

template <>
class GUIEvent<void>
{
public:
	GUIEvent();
	~GUIEvent();

	void operator +=(IDelegate<void> *delegate);
	void operator ()(GUIWindow *sender);

	bool hasDelegate() const;

private:
	GUIEvent(const GUIEvent &event);
	GUIEvent & operator =(const GUIEvent &);

	std::vector<IDelegate<void> *>	m_delegates;
};

#include "GUIEvent.inl"

#endif