#include "MemoryLog.h"

template <class Param>
GUIEvent<Param>::GUIEvent()
{
}

template <class Param>
GUIEvent<Param>::~GUIEvent()
{
	for(std::vector<IDelegate<Param> *>::iterator it = m_delegates.begin(); it != m_delegates.end(); ++it)
	{
		delete (*it);
	}
}

template <class Param>
void GUIEvent<Param>::operator +=(IDelegate<Param> *delegate)
{
	m_delegates.push_back(delegate);
}

template <class Param>
void GUIEvent<Param>::operator ()(GUIWindow *sender, Param p)
{
	for(std::vector<IDelegate<Param> *>::iterator it = m_delegates.begin(); it != m_delegates.end(); ++it)
	{
		(**it)(sender, p);
	}
}

template <class Param>
bool GUIEvent<Param>::hasDelegate() const
{
	return !m_delegates.empty();
}

#undef new