#ifndef H_GUIFRAME
#define H_GUIFRAME

#include "GUIWindow.h"

class GUITexture;

enum EFloatType
{
	FT_FLOAT,
	FT_DOCKLEFT,
	FT_DOCKRIGHT,
	FT_DOCKTOP,
	FT_DOCKBOTTOM,
};

class GUIFrame: public GUIWindow
{
public:
	GUIFrame(GUI *gui, const std::string &name, GUIWindow *parent, const std::string &title);
	virtual ~GUIFrame();

	virtual Position & getClientPosition();
	virtual Size & getClientSize();
	virtual const Position & getClientPosition() const;
	virtual const Size & getClientSize() const;
	virtual D3DXVECTOR2 clientToWindowSize(const D3DXVECTOR2 &size);

	void setType(EFloatType type);
	void setTitle(const std::string &title);

protected:
	virtual void renderSelf(Renderer &renderer) const;
	virtual bool onMouseDrag(const D3DXVECTOR2 &lastPos, const D3DXVECTOR2 &pos, unsigned buttons);

	bool isInHeader(const D3DXVECTOR2 &point) const;

private:
	GUILabel	*m_labelTitle;
	GUITexture	*m_edges[8];
	GUITexture	*m_background;
	Size		 m_clientSize;
	Position	 m_clientPosition;
	EFloatType	 m_type;
};

#endif