#ifndef H_GUILABEL
#define H_GUILABEL

#include "GUIWindow.h"
#include "GUIEvent.h"
#include <string>

class Font;

class GUILabel: public GUIWindow
{
public:
	GUILabel(GUI *gui, const std::string &name, GUIWindow *parent, const std::string &text = "", Font *font = NULL);
	virtual ~GUILabel();

	void setText(const std::string &text);
	const std::string & getText() const;

	void setFont(Font *font);
	void setColor(const D3DXVECTOR4 &color);

	GUIEvent<void> onClick;

protected:
	virtual bool onMouseClick(const D3DXVECTOR2 &pos, unsigned button);
	virtual void renderSelf(Renderer &renderer) const;
	void updateSize();

private:
	D3DXVECTOR4	 m_color;
	std::string	 m_text;
	Font		*m_font;
};

#endif