#ifndef GUILISTBOX
#define GUILISTBOX

#include "GUIWindow.h"
#include "GUIEvent.h"
#include <vector>

class GUITexture;
class GUILabel;

class GUIListBox: public GUIWindow
{
public:
	GUIListBox(GUI *gui, const std::string &name, GUIWindow *parent);
	virtual ~GUIListBox();

	unsigned getNbElements() const;
	void addElement(const std::string &label);
	void setActive(int index, bool active);
	int getSelectedItem() const;
	void select(int index);

	void autoSize();

	GUIEvent<int> onItemSelected;

protected:
	virtual void renderSelf(Renderer &renderer) const;
	void onLabelClick(GUIWindow *sender);

private:
	struct Element
	{
		GUILabel	*m_label;
		bool		 m_active;

		Element(GUILabel *label, bool active);
	};

	GUITexture				*m_background;
	GUITexture				*m_highlight;
	std::vector<Element>	 m_elems;
	int						 m_selectedItem;
};

#endif