#include "GUIMessageBox.h"
#include "GUILabel.h"
#include "GUIButton.h"
#include "GUI.h"
#include "MemoryLog.h"

GUIMessageBox::ResultEventArg::ResultEventArg(EMessageBoxButton button):
m_button(button)
{
}

EMessageBoxButton GUIMessageBox::ResultEventArg::getButton() const
{
	return m_button;
}

GUIMessageBox::GUIMessageBox(GUI *gui, const std::string &title, const std::string &message, EMessageBoxType type):
GUIFrame(gui, "", gui->getRoot(), title)
{
	GUILabel *labelMessage = new GUILabel(gui, "", this, message);
	labelMessage->getPosition().setPosition(D3DXVECTOR2(0.0f, 4.0f), GA_TOP, GA_TOP);

	getSize().setAbsoluteSize(clientToWindowSize(labelMessage->getSize().getAbsoluteSize() + D3DXVECTOR2(40.0f, 32.0f)));
	getPosition().setPosition(D3DXVECTOR2(0.0f, 0.0f), GA_CENTER, GA_CENTER);

	switch(type)
	{
	case MBT_OK:
		{
			GUIButton *ok = new GUIButton(gui, "okButton", this, "Ok");
			ok->getPosition().setPosition(D3DXVECTOR2(-4.0f, -4.0f), GA_BOTTOMRIGHT, GA_BOTTOMRIGHT);
			ok->getSize().setAbsoluteSize(D3DXVECTOR2(50.0f, 16.0f));
			ok->onClick += new Delegate<GUIMessageBox, void>(this, &GUIMessageBox::onClickButton);
			break;
		}
	case MBT_YESNO:
		{
			GUIButton *yes = new GUIButton(gui, "yesButton", this, "Oui");
			yes->getPosition().setPosition(D3DXVECTOR2(-58.0f, -4.0f), GA_BOTTOMRIGHT, GA_BOTTOMRIGHT);
			yes->getSize().setAbsoluteSize(D3DXVECTOR2(50.0f, 16.0f));
			yes->onClick += new Delegate<GUIMessageBox, void>(this, &GUIMessageBox::onClickButton);

			GUIButton *no = new GUIButton(gui, "noButton", this, "Non");
			no->getPosition().setPosition(D3DXVECTOR2(-4.0f, -4.0f), GA_BOTTOMRIGHT, GA_BOTTOMRIGHT);
			no->getSize().setAbsoluteSize(D3DXVECTOR2(50.0f, 16.0f));
			no->onClick += new Delegate<GUIMessageBox, void>(this, &GUIMessageBox::onClickButton);
			break;
		}
		break;
	case MBT_YESNOCANCEL:
		break;
	}
}

void GUIMessageBox::onClickButton(GUIWindow *sender)
{
	if(sender->getName() == "okButton")
	{
		ResultEventArg e(MBB_OK);
		onClose(this, e);
	}
	else if(sender->getName() == "yesButton")
	{
		ResultEventArg e(MBB_YES);
		onClose(this, e);
	}
	else if(sender->getName() == "noButton")
	{
		ResultEventArg e(MBB_NO);
		onClose(this, e);
	}

	close();
}