#ifndef H_GUITEXTURE
#define H_GUITEXTURE

#include <string>
#include <d3dx9.h>
#include "GUI.h"
#include "Position.h"
#include "Size.h"

class MediaManager;
class Texture;
class Renderer;
class GUIWindow;

class GUITexture
{
public:
	GUITexture(MediaManager &media, const std::string &textureName, const GUIWindow &owner);
	~GUITexture();

	void render(Renderer &renderer, const GUI &gui);

	const Size & getSize() const;
	Size & getSize();
	const Position & getPosition() const;
	Position & getPosition();

	void setAlpha(float alpha);

private:
	float							 m_alpha;
	Size							 m_size;
	Position						 m_pos;
	Texture							*m_texture;
	VertexBuffer<GUIVertex>::Type	*m_vb;
};

#endif