#ifndef H_GUITRACKBAR
#define H_GUITRACKBAR

#include "GUIWindow.h"
#include "GUIEvent.h"

class GUITexture;

class GUITrackbar: public GUIWindow
{
public:
	GUITrackbar(GUI *gui, const std::string &name, GUIWindow *parent);
	virtual ~GUITrackbar();

	float getStart() const;
	float getEnd() const;
	float getValue() const;
	float getStep() const;

	void setStart(float start);
	void setEnd(float end);
	void setValue(float value, bool forceNotify = false);
	void setStep(float step);

	GUIEvent<float> onValueChanged;

protected:
	virtual void updateSelf(float elapsedTime);
	virtual void renderSelf(Renderer &renderer) const;
	virtual bool onMouseClick(const D3DXVECTOR2 &pos, unsigned button);
	virtual bool onMouseRelease(const D3DXVECTOR2 &pos, unsigned button);
	virtual bool onMouseDrag(const D3DXVECTOR2 &lastPos, const D3DXVECTOR2 &pos, unsigned buttons);

	void setTrackerPosition();
	bool isInTracker(const D3DXVECTOR2 &point) const;

private:
	GUITexture	*m_textures[2];
	float		 m_step;
	float		 m_start;
	float		 m_end;
	float		 m_value;
};

#endif