#ifndef H_GENALLOTMENT
#define H_GENALLOTMENT

#include "generator.h"
#include "Buffer.h"
#include "Allotment.h"
#include "BlockSet.h"
#include <d3dx9.h>
#include <list>
#include <vector>

class GenAllotment : public Generator
{
public:
	GenAllotment(const BlockSet &blocks, BlockSet &allotments);
	~GenAllotment(void);

	virtual bool isFinished() const;
	virtual void commitChange();

protected:
	virtual void proceed();
	virtual void createParameters(Control *control);
	virtual void attachControl(Control *control);

	std::list<Allotment*> generate(Allotment *A);

private:
	const BlockSet	*m_blocks;
	BlockSet		*m_allotments;
	unsigned		 m_actBlock;

	float			 m_maxArea;
	float			 m_minArea;	
};
#endif