#ifndef H_GENBUILDING
#define H_GENBUILDING

#include "generator.h"
#include "Density.h"
#include "BlockSet.h"
#include "Building.h"
#include "BuildingSet.h"
#include "Allotment.h"
#include <d3dx9.h>
#include <list>
#include <vector>

class GenBuilding : public Generator
{
public:
	GenBuilding(const BlockSet &allotments, BuildingSet &buildings, Density &density);
	~GenBuilding(void);
	virtual bool isFinished() const;
	virtual void commitChange();
	
	virtual void attachControl(Control *control);

protected:
	virtual void proceed();
	virtual void createParameters(Control *control);

	Building* generate(Allotment *allotment);

private:
	const BlockSet	*m_allotments;
	BuildingSet		*m_buildings;
	unsigned		 m_actBlock;
	Density			*m_density;

	float			 m_heightBuilding;
	float			 m_buildingRange;
	float			 m_thresholdDensity1;
	float			 m_thresholdDensity2;
	float			 m_coeffHeight1;
	float			 m_coeffHeight2;
};
#endif