#ifndef H_GENCENTERS
#define H_GENCENTERS

#include "Generator.h"
#include "Density.h"
#include <d3dx9.h>

class GenCenters : public Generator
{
public:
	GenCenters(Density &density);
	~GenCenters(void);

	virtual bool isFinished() const;
	virtual void commitChange();

	virtual void attachControl(Control *control);

protected:
	virtual void init();
	virtual void proceed();
	virtual void createParameters(Control *control);

	void genCenter(ECenterType type);

private:
	struct NearPoint
	{
		int x;
		int y;
		int distance;
	};

	Density					*m_density;
	std::vector<D3DXVECTOR2> m_history;
	int						 m_nbExecutions;
	bool					 m_startExec;
	NearPoint				*m_closestPointOutOfWater;

	float	m_innerRadius;
	float	m_innerRadiusRange;
	float	m_outerRadiusProportion;
	float	m_outerRadiusProportionRange;
	float	m_nbCentersBasic;
	float	m_nbCentersRaster;
	float	m_nbCentersRadial;

	D3DXVECTOR2 findPosition (const Center &c) const;
	void computeClosestPointOutOfWater();
};

#endif