#ifndef H_GENDENSITY
#define H_GENDENSITY

#include "generator.h"
#include <d3dx9.h>

class Density;

class GenDensity : public Generator
{
public:
	GenDensity(Density &density);
	~GenDensity(void);

	virtual bool isFinished() const;
	virtual void commitChange();

	virtual void attachControl(Control *control);

protected:
	virtual void proceed();
	virtual void createParameters(Control *control);

private:
	Density		*m_density;
	int			 m_x, 
				 m_y;

	float		 m_borderCenterDensity;
	float		 m_pow;
	float		 m_elevationRange;

	/* computeZoneScore
	Retourne une densite comprise entre 0 et 1 pour la position actuelle. */
	float computeZoneDensity() const;
	
};

#endif