#ifndef H_GENENVIRONMENT
#define H_GENENVIRONMENT 

#include "Environment.h"
#include "Generator.h"

class GenEnvironment : public Generator
{
public:
	GenEnvironment(Environment &env);
	~GenEnvironment(void);
	/* getter et setter */
	float getPersistence() const;
	float getAmplitude() const;
	void setPersistence (float persistence);
	void setAmplitude (float amplitude);

	virtual bool isFinished() const;
	virtual void commitChange();

	virtual void attachControl(Control *control);

protected:
	virtual void proceed();
	virtual void createParameters(Control *control);

private:
	Environment *m_env;
	int			 m_step;
	float		 m_amplitude,
				 m_persistence,
				 m_octave;

	float cubicInterpolation(float y0, float y1, float y2, float y3, float x);
	int findXReferencePoint(int i, int j, int refPointPosition, int inc, int width);
	int findYReferencePoint(int i, int j, int refPointPosition, int inc, int width);

};

#endif