#include "Generator.h"
#include "Control.h"
#include "utils.h"
#include <windows.h>
#include "MemoryLog.h"

Generator::Generator(const std::string &name):
m_name(name),
m_init(false)
{
}

Generator::~Generator()
{
}

void Generator::commitChange()
{
}

Control * Generator::newControl(GUI *gui)
{
	Control *control = new Control(gui, m_name);

	control->addParameter("seed", "Seed", 0.0f, 65535.0f, randomFloat(0.0f, 65535.0f), 1.0f);

	createParameters(control);

	return control;
}

void Generator::attachControl(Control *control)
{
	control->attachValue("seed", m_seed);
}

void Generator::init()
{
}

void Generator::finish()
{
}

void Generator::proceed(float time)
{
	LARGE_INTEGER actTime, endTime, frequency;
	QueryPerformanceFrequency(&frequency);
	QueryPerformanceCounter(&actTime);

	endTime.QuadPart = actTime.QuadPart + static_cast<LONGLONG>(time * frequency.QuadPart);

	if(!m_init)
	{
		srand(static_cast<unsigned int>(m_seed));
		init();
		m_init = true;
	}

	while(actTime.QuadPart < endTime.QuadPart && !isFinished())
	{
		proceed();
		QueryPerformanceCounter(&actTime);
	}

	commitChange();

	if(isFinished())
	{
		finish();
	}
}
