#ifndef H_GENERATOR
#define H_GENERATOR

#include <string>

class Control;
class GUI;

class Generator
{
public:
	Generator(const std::string &name);
	virtual ~Generator();

	void proceed(float time);

	virtual bool isFinished() const =0;
	virtual void commitChange();

	Control * newControl(GUI *gui);
	virtual void attachControl(Control *control);

protected:
	virtual void init();
	virtual void finish();
	virtual void proceed() =0;
	virtual void createParameters(Control *control) =0;

private:
	float		m_seed;
	std::string m_name;
	bool		m_init;
};

#endif