#ifndef H_INTERSECTION
#define H_INTERSECTION

#include <vector>
#include "HashMap.h"

#define TIMETOPASS 6.0f
#define TIMETOPASSNEXT TIMETOPASS * 2.0f

class Junction;
class Way;
class Agent;

class Intersection
{
public :
	Intersection();
	~Intersection(void);

	void addJunction(Junction& junction);
	void update(float timeElapsed);
	virtual bool passable(const Agent& agent) const;
	virtual void agentPass(const Agent& agent);
	virtual void init();	
	virtual bool isPrioritary(const Agent& agent) const;	
	const std::vector<Junction*>& getJunctions() const;
	const std::vector<Intersection*>& getNextIntersections() const;
	const std::vector<Way*>& getInnerWays() const;
	Way* getWayTo (const Intersection& destination) const;
	unsigned getIndex()const;
	void setIndex(unsigned);

protected :
	std::vector<Junction*>		m_junctions;
	std::vector<Way*>			m_innerWays;
	std::vector<Way*>			m_outerWays;
	std::vector<Intersection*>	m_accessTo;
	float						m_roadWidth;
	int							m_index;

	bool enoughSpaceInDestination(const Agent&) const;

private:
	virtual void pUpdate(float timeElapsed);
};

#endif