#ifndef H_INTERSECTIONPRIORITY
#define H_INTERSECTIONPRIORITY

#include "intersection.h"
#include <vector>

class Agent;
class Junction;

class IntersectionPriority : public Intersection
{
public:
	// main1 et main2 sont les deux voies prioritaires. Elles correspondent  deux junctions d'entre (par exemple 0 et 6)
	IntersectionPriority();
	IntersectionPriority(const Junction& main1, const Junction& main2);
	~IntersectionPriority(void);

	bool passable(const Agent& agent) const;
	void init();
	bool isPrioritary(const Agent& agent) const;

private:
	mutable std::vector<const Agent*>	m_waitingAgents;
	const Junction						*m_main1,
										*m_main2;

	void pUpdate(float timeElapsed);
	bool agentCrossWay (const Way& way) const;
	bool agentCrossJunction (const Junction& junc) const;

	bool isIntersectionTrafficLight()const;
};

#endif