#ifndef H_INTERSECTIONTRAFFICLIGHT
#define H_INTERSECTIONTRAFFICLIGHT

#include "intersection.h"
#include <vector>
#include <d3dx9math.h>

class IntersectionTrafficLight : public Intersection
{
public:
	IntersectionTrafficLight();
	~IntersectionTrafficLight(void);

	void init();	bool passable(const Agent& agent) const;
	bool isGreen(const Junction& junction) const;
	D3DXVECTOR3 getColor(const Junction& junction) const;

private:

	float		m_timeSinceLastSwitch,
				m_safetyTime;
	unsigned	m_indiceCurrentsGreen;

	std::vector<std::vector<unsigned>*>	m_synchronizedLights;
	std::vector<float> m_switchTime;
	bool		m_orange;

	void pUpdate(float timeElapsed);
	void createSynchro(std::vector<const Way*>&);
	bool agentCrossFrontWay(const Agent& agent, const Way& front, const Way& out) const;
};

#endif