#ifndef H_Junction
#define H_Junction

#include <d3dx9math.h>
#include <vector>

class Intersection;
class Way;
class Agent;

class Junction
{
public:
	Junction(const D3DXVECTOR3 &pos, Intersection &intersection);	~Junction(void);

	void addWayIn (Way* const in);
	void addWayOut (Way* const out);
	bool passable(const Agent& agent) const;
	void agentPass(const Agent& agent);
	
	const std::vector<Way*>& getWaysIn() const;
	const std::vector<Way*>& getWaysOut() const;
	Intersection& getIntersection() const;
	unsigned getIntersectionIndice() const;
	const Agent* getNearestAgentArriving() const;
	const D3DXVECTOR3& getPosition() const;
	const Way& getWayInNotFromIntersection(const Intersection& intersection) const;
	void setIntersectionIndice (unsigned indice);

private:
	D3DXVECTOR3			m_position;
	std::vector<Way*>	m_waysIn;
	std::vector<Way*>	m_waysOut;
	Intersection*		m_intersection;
	unsigned			m_intersectionIndice;
};

#endif