#ifndef H_MEDIAMANAGER
#define H_MEDIAMANAGER

class Renderer;

#include "ResourceManager.h"
#include "Shader.h"
#include "Texture.h"
#include "Font.h"
#include "Sound.h"

class MediaManager:
	protected ResourceManager<Shader>,
	protected ResourceManager<Texture>,
	protected ResourceManager<Font>,
	protected ResourceManager<Sound>
{
public:
	MediaManager(Renderer &renderer);
	~MediaManager();

	template <class T>
	T * getObject(const std::string &objectName);
	template <class T>
	void removeReference(const T * ref);

	void onLostDevice();
	void onResetDevice();

	Renderer & getRenderer() const;

private:
	MediaManager(const MediaManager &);
	MediaManager & operator =(const MediaManager &);

	Renderer	&m_renderer;
};

#include "MediaManager.inl"

#endif