#ifndef H_MEMORYLOG
#define H_MEMORYLOG

#ifdef _DEBUG

class MemoryLog
{
public:
	static void * alloc(unsigned size, const char *file, int line, bool array);
	static void free(void *ptr, bool array);
	static void dump(const char *filename);
	static void breakOnId(unsigned id);
};

inline void * operator new(unsigned size, const char *file, int line)
{
	return MemoryLog::alloc(size, file, line, false);
}

inline void * operator new[](unsigned size, const char *file, int line)
{
	return MemoryLog::alloc(size, file, line, true);
}

inline void operator delete(void *ptr)
{
	MemoryLog::free(ptr, false);
}

inline void operator delete[](void *ptr)
{
	MemoryLog::free(ptr, true);
}

inline void operator delete(void *ptr, const char*, int)
{
	MemoryLog::free(ptr, false);
}

inline void operator delete[](void *ptr, const char *, int)
{
	MemoryLog::free(ptr, true);
}
	
#endif

#endif

#ifdef _DEBUG
#ifndef new
#define new new(__FILE__, __LINE__)
#endif
#endif