#ifndef H_PARAMETERSPOOL
#define H_PARAMETERSPOOL

#include <d3dx9.h>
#include "HashMap.h"

struct ParameterRef
{
	LPD3DXEFFECT m_effect;
	D3DXHANDLE m_handle;

	ParameterRef() {}
	ParameterRef(LPD3DXEFFECT effect, D3DXHANDLE handle):
	m_effect(effect), m_handle(handle) {}
};


class ParametersPool
{
public:
	ParametersPool();
	~ParametersPool();

	LPD3DXEFFECTPOOL getPool() const;
	void registerSharedParameters(LPD3DXEFFECT effect);

	void setValue(const std::string &parameter, float value) const;
	void setValue(const std::string &parameter, const D3DXVECTOR3 *value) const;
	void setValue(const std::string &parameter, const D3DXVECTOR4 *value) const;
	void setValue(const std::string &parameter, const D3DXMATRIX *value) const;

private:
	LPD3DXEFFECTPOOL						m_pool;
	HashMap<std::string, ParameterRef, 32>	m_parameters;
};

#endif