#ifndef H_PATHFINDING
#define H_PATHFINDING 

class Graph;
class Intersection;

class Pathfinding
{
public:
	Pathfinding(Graph &);
	~Pathfinding();
	void setGraph(Graph*);
	void init(void);
	void FloydWarshall(float highwayRatio);
	Intersection * next(const Intersection&, const Intersection&) const;
	float* getW()const;
	int* getNextIntersection()const;

private:
	Graph	*m_graph;
	float	*m_W;
	int		*m_nextIntersection;
	float	 m_lastHighwayRatio;
};

#endif
