#ifndef H_POSITION
#define H_POSITION

#include <d3dx9.h>

class Size;

enum EAnchor
{
	GA_NONE,
	GA_TOPLEFT,
	GA_TOP,
	GA_TOPRIGHT,
	GA_LEFT,
	GA_CENTER,
	GA_RIGHT,
	GA_BOTTOMLEFT,
	GA_BOTTOM,
	GA_BOTTOMRIGHT
};

class Position
{
public:
	Position(const Position *parentPos, const Size &size,
		const D3DXVECTOR2 &offset = D3DXVECTOR2(0.0f, 0.0f),
		EAnchor relativePoint = GA_TOPLEFT,
		EAnchor point = GA_TOPLEFT);

	void setPosition(const D3DXVECTOR2 &offset);
	void setPosition(const D3DXVECTOR2 &offset, EAnchor relativePoint, EAnchor point);
	void move(const D3DXVECTOR2 &distance);

	D3DXVECTOR2 getAbsolutePosition() const;

	void setParentPosition(const Position *parentPos);

private:
	D3DXVECTOR2 getAnchorPosition(EAnchor anchor) const;
	D3DXVECTOR2 getAnchorOffset(EAnchor anchor) const;

	Position(const Position &);
	Position & operator =(const Position &);

	const Position	*m_parentPos;
	const Size		&m_size;
	D3DXVECTOR2		 m_offset;
	EAnchor			 m_point;
	EAnchor			 m_relativePoint;
};

#endif