#ifndef H_SHADER
#define H_SHADER

#include "HashMap.h"
#include <d3dx9.h>

class Texture;

class Shader
{
public:
	Shader(LPD3DXEFFECT effect);
	~Shader();

	void setValue(D3DXHANDLE parameterBlock) const;
	void setValue(const std::string &parameter, float value) const;
	void setValue(const std::string &parameter, const D3DXVECTOR2 *value) const;
	void setValue(const std::string &parameter, const D3DXVECTOR3 *value) const;
	void setValue(const std::string &parameter, const D3DXVECTOR4 *value) const;
	void setValue(const std::string &parameter, const D3DXMATRIX *value) const;
	void setValue(const std::string &parameter, const D3DXVECTOR4 *value, unsigned count) const;
	void setTexture(const std::string &parameter, const Texture *texture) const;

	void begin();
	void end();
	bool nextPass();

	void onLostDevice();
	void onResetDevice();

private:
	void getHandles();

	LPD3DXEFFECT							m_effect;
	HashMap<std::string, D3DXHANDLE, 32>	m_handles;
	unsigned								m_nbPasses;
	unsigned								m_actPass;
};

#endif