#include "ShaderLoader.h"
#include "MediaManager.h"
#include "Renderer.h"
#include <fstream>
#include "MemoryLog.h"

ShaderLoader::~ShaderLoader()
{
}

Shader * ShaderLoader::load(const std::string &fileName, MediaManager &media) const
{
	std::ifstream file(fileName.c_str());
	std::string src;
	std::string line;

	if(!file.is_open())
	{
		throw std::exception(("Can't create shader " + fileName + ":\n File not found").c_str());
	}

	while(getline(file, line))
	{
		src += line + "\n";
	}

	file.close();

	LPD3DXEFFECT effect = media.getRenderer().createShader(src);

	D3DXHANDLE techniqueHandle;
	if(FAILED(effect->FindNextValidTechnique(NULL, &techniqueHandle)))
	{
		effect->Release();
		return NULL;
	}

	if(FAILED(effect->SetTechnique(techniqueHandle)))
	{
		effect->Release();
		return NULL;
	}

	return new Shader(effect);
}