#ifndef H_SIZE
#define H_SIZE

#include <d3dx9.h>

class Size
{
public:
	Size(const Size *parentSize);
	Size(const Size *parentSize, const D3DXVECTOR2 &absoluteSize);
	Size(const Size *parentSize, const D3DXVECTOR2 &offset, const D3DXVECTOR2 &scale);

	void setAbsoluteSize(const D3DXVECTOR2 &size);
	void setRelativeSize(const D3DXVECTOR2 &offset, const D3DXVECTOR2 &scale);

	void setAbsoluteSizeX(float size);
	void setAbsoluteSizeY(float size);
	void setRelativeSizeX(float offset, float scale);
	void setRelativeSizeY(float offset, float scale);

	D3DXVECTOR2 getAbsoluteSize() const;

	void setParentSize(const Size *parentSize);

private:
	Size(const Size &);
	Size & operator =(const Size &);

	D3DXVECTOR2	m_offset;
	D3DXVECTOR2	m_scale;
	const Size *m_parentSize;;
};

#endif