#ifndef H_SOUNDENGINE
#define H_SOUNDENGINE

#include <string>
#include <vector>
#include <d3dx9math.h>

struct IXAudio2;
struct IXAudio2MasteringVoice;
class Sound;
class Speaker;
class Camera;

//#define NO_SOUND

class SoundEngine
{
public:
	SoundEngine();
	~SoundEngine();

	Speaker * createSpeaker(const Sound *sound);
	void eraseSpeaker(const Speaker *speaker);
	void update(float elapsedTime, const Camera &camera);

private:
	IXAudio2				*m_objectXAudio2;
	IXAudio2MasteringVoice	*m_masterVoice;
	std::vector<Speaker *>	 m_speakers;
	D3DXVECTOR3				 m_cameraLastPosition;
};

#endif