#include "SoundException.h"
#include "MemoryLog.h"

SoundException::SoundException(int errorCode, const std::string &message):
std::exception(message.c_str()),
m_errorCode(errorCode)
{
}

int SoundException::getHResult() const
{
	return m_errorCode;
}

bool SoundException::isFailed() const
{
	return (m_errorCode & 0x80000000) != 0;
}

int SoundException::getFacility() const
{
	return (m_errorCode >> 16) & 0x1FFF;
}

int SoundException::getErrorCode() const
{
	return m_errorCode & 0xFFFF;
}