#include "Texture.h"
#include "MemoryLog.h"

Texture::Texture(LPDIRECT3DTEXTURE9 texture):
m_texture(texture)
{
}

Texture::~Texture()
{
	m_texture->Release();
}

LPDIRECT3DTEXTURE9 Texture::getData() const
{
	return m_texture;
}

DynamicTexture::DynamicTexture(LPDIRECT3DTEXTURE9 texture, const Image<unsigned short> &source):
Texture(texture),
m_source(&source)
{
}

DynamicTexture::~DynamicTexture()
{
}

void DynamicTexture::update()
{
	D3DLOCKED_RECT outRect;
	m_texture->LockRect(0, &outRect, NULL, 0);
	CopyMemory(outRect.pBits, m_source->getData(), sizeof(unsigned short) * m_source->getWidth() * m_source->getHeight());
	m_texture->UnlockRect(0);
	m_texture->GenerateMipSubLevels();
}