#include "utils.h"
#include <cmath>
#include <stdlib.h>
#include "MemoryLog.h"

float randomFloat(const float min, const float max)
{
	return (static_cast<float>(rand())/RAND_MAX) * (max-min) + min;
}

float randomFloatInRange(float midRange, float range)
{
	return midRange * randomFloat(1.0f - range, 1.0f + range);
}

int randomInt(const int min, const int max)
{
	return (rand() * (max - min)) / (RAND_MAX + 1) + min;
}

bool randomBool(float prob)
{
	return (static_cast<float>(rand()) / RAND_MAX <= prob);
}

bool isInRect(const D3DXVECTOR2 &min, const D3DXVECTOR2 &max, const D3DXVECTOR2 &point)
{
	return (point.x >= min.x && point.x < max.x && point.y >= min.y && point.y < max.y);
}

float vectorAngle(const D3DXVECTOR2 &vector)
{
	D3DXVECTOR2 dir = vector;
	D3DXVec2Normalize(&dir, &dir);

	float angle = std::acos(dir.x);
	return (dir.y < 0.0f) ? -angle : angle;
}