#ifndef H_UTILS
#define H_UTILS

#include <d3dx9.h>

#ifndef M_PI
#define M_PI 3.14159265f
#endif

float	randomFloat	(const float min, const float max);
float	randomFloatInRange (float midRange, float range);
int		randomInt	(const int min, const int max);
bool	randomBool(float prob);

template<class Format> void fillArray(Format *array, Format value, int size);

bool isInRect(const D3DXVECTOR2 &min, const D3DXVECTOR2 &max, const D3DXVECTOR2 &point);

template <class T> void clamp(T &value, T min, T max);

float vectorAngle(const D3DXVECTOR2 &vector);

template<int Number>
struct StaticLog
{
	enum { Value = StaticLog<Number / 2>::Value + 1 };
};

template<>
struct StaticLog<1>
{
	enum { Value = 0 };
};

#include "utils.inl"

#endif